.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data
MyWords	dw 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsA
		counter_end
		print str$(eax), 9, "cycles for AddWordsA", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsB
		counter_end
		print str$(eax), 9, "cycles for AddWordsB", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsC
		counter_end
		print str$(eax), 9, "cycles for AddWordsC", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsD
		counter_end
		print str$(eax), 9, "cycles for AddWordsD", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsE
		counter_end
		print str$(eax), 9, "cycles for AddWordsE", 13, 10
		print chr$(13, 10)
	ENDM
	CodeSize AddWordsA
	CodeSize AddWordsB
	CodeSize AddWordsC
	CodeSize AddWordsD
	CodeSize AddWordsE
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
AddWordsA_s:
AddWordsA proc
	xor eax, eax
	ffree st(7)
	mov esi, offset MyWords
	push eax	; create a slot
	fldz
	m2m ecx, 20
	.Repeat
		dec ecx
		movzx eax, word ptr [esi+2*ecx]
		mov [esp], eax
		fiadd dword ptr [esp]
	.Until Zero?
		if 0
		fistp dword ptr [esp]	; return result in eax, very slow
		pop eax
		else
		fstp st	; for testing, discard result in ST(0)
		pop eax
		endif
 ret
AddWordsA endp
AddWordsA_endp:

align 16
AddWordsB_s:
AddWordsB proc
	mov esi, offset MyWords
	push esi
	xor eax, eax
	ffree st(7)
	push eax	; zero the hiword
	fldz
	m2m ecx, 20
	.Repeat
		lodsw
		mov [esp], eax
		fiadd dword ptr [esp]
		dec ecx
	.Until Zero?
	pop esi
	fistp dword ptr [esp]	; return result in eax, fast
	pop eax
  ret
AddWordsB endp
AddWordsB_endp:

align 16
AddWordsC_s:
AddWordsC proc
	mov esi, offset MyWords
	push esi
	xor eax, eax
	ffree st(7)
	push eax	; zero the hiword
	fldz
	lea ecx, [esi+40]
	.Repeat
		lodsw
		mov [esp], eax
		fiadd dword ptr [esp]
	.Until esi>=ecx
	pop esi
	fistp dword ptr [esp]	; return result in eax
	pop eax
  ret
AddWordsC endp
AddWordsC_endp:

align 16
AddWordsD_s:
AddWordsD proc
	mov esi, offset MyWords
	ffree st(7)
	fldz
	m2m ecx, 20
	.Repeat
		dec ecx
		fiadd word ptr [esi+2*ecx]	; will not yield correct results for unsigned words
	.Until Zero?
	fstp st
  ret
AddWordsD endp
AddWordsD_endp:

align 16
AddWordsE_s:
AddWordsE proc
	ffree st(7)
	mov esi, offset MyWords
	push 0	; create a slot
	fldz
	m2m ecx, 20
	align 16
	.Repeat
		pop ax
		dec ecx
		push word ptr [esi+2*ecx]	; this is horribly slow...!
		fiadd dword ptr [esp]
	.Until Zero?
		if 0
		fistp dword ptr [esp]	; return result in eax, very slow
		pop eax
		else
		fstp st	; result was in ST(0)
		pop eax
		endif
 ret
AddWordsE endp
AddWordsE_endp:


ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]